package ca.mun.cs.av;

import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.math.Affine2;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.utils.Disposable;
import com.badlogic.gdx.utils.FloatArray;


interface Tree extends Disposable {

    /**
     * Draws the tree.
     */
    void draw(SpriteBatch batch);

    /**
     * Adds a drop of water, which might contribute to the tree's growth.
     */
    void addDrop();

    /**
     * Updates the tree's state by checking whether the growth level should be advanced based on
     * the amount of water absobed.
     */
    void update();

    /**
     * @return Whether (x, y) is within a threshold distance of any leaf points.
     */
    boolean closeToAnyLeafPoints(float x, float y);
}
